Unit jbEdit;
{
 Extended component TEdit
 (c) 1997-99 J.BENES, All right reserved
 Procedure Parser
 (c) 1997 Antonie Baars, All right reserved
   E-mail:"d950021@icpc00.icpc.fukui-u.ac.jp"
}
{$Define Use_RX_Lib}
Interface
Uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Menus, Dialogs, StdCtrls, Buttons, Mask{$IfDef Use_RX_Lib}, ToolEdit,
  CurrEdit, RXCtrls, FileCtrl, DateUtil{$Endif};

{
Uvodem:
-------

Rozsireni vzniklo pro validaci dat a pro zmenu barvy pole pri disablovanem
poli. Pri teto prilezitosti jsem pridal dalsi eventy a nove property.


Rozsireni:
Nove property:
--------------

Capitalize - pocatecni pismena jsou konvertovana na velka

ColorOnDisabled
ColorOnFocus
ColorOnNotFocus - zmena barev pro zamerene pole, hlavne zmena
                  kdyz pole ma enabled=false

EditType - je mozno si vybrat mezi stringem, celym cislem, floatem a
           parserem pro vyhodnoceni jednoduchych vyrazu. Vyhodnoceni se
           deje pri ztrate focusu. Je-li typem cislo, je testovano, zda je
           cislem platnym a interne je sledovan vstup znaku na cisla.
           Parserem je mozne ohodnocovat vyrazu napr. vyraz
             sqrt(0.5*exp(x)-0.5*exp(y))


Mask - v tomto retezci se uschovava maska k formatovani dle nejakych
       pravidel. Zde se nic neformatuje, predpoklada se specialni vnejsi rutina,
       povesena na OnMask.

Required - nastavuje se na True, je-li pozadovano neprazdne pole.

ValidChars - retezec, kde se uschovavaji platne znaky, test se provadi pouze pro
             typ EditType = teString;

Nove events:
------------

OnConvert - lze pouzit pro konverzi pri EditType = teInteg ze soustavy
            napr. oktalove do desitkove k editaci a zpet. Smer konverze je
            udavan promenou ToDirection, ktera nabyva dvou hodnot:

            ** zde je priklat pouziti s uzitim rutin z jbStr modulu **

            procedure TForm1.PubEdit1Convert(Sender: TObject;
              ToDirection: TToDirection; var Value: OpenString);
            begin
              If Value <> '' Then // jen kdyz je treba
                Case ToDirection of
                  // hodnota se meni z oktalove na desitkovou
                  eValueToText: Value := IntToStr(Num(Value,8));
                  // hodnota se meni z desitkove zpet na oktalovou
                  eTextToValue: Value := Doc(StrToInt(Value),8);
                End;
            end;

OnError - umoznuje zakryt standardni hlasky a nahradit je svymi.

OnMask - umoznuje formatovat retezec v editacnim poli pri
         EditType = teString; Znamena to, ze tam mohou byt ruzne
         znaky, ktere se az nasledne zaformatuji.

         ** zde je priklat pouziti s uzitim rutin z jbStr modulu **

         procedure TForm1.PubEdit1Mask(Sender: TObject; ToDirection: TToDirection;
           Mask: String; var Value: OpenString);
         begin
           If Value <> '' Then // jen kdyz je treba
             Case ToDirection of
               // formatujeme 10 mistne rodne cislo
               // editovat se bude pouze text, je vhodne jeste nastavit
               // ValidChars := '0123456789'
               // odstranuji se vsechny oddelovace pred editaci
               eValueToText:Value:=Strip('XX XX XX XXXX',Value);
               // vkladaji se oddelovace po editaci
               eTextToValue:Value:=Zip('XX.XX.XX/XXXX',Value);
             End;
         end;

         Pozn. Funkce je vyvolana dvakrat - poprve regulerne pro upravu
               a podruhe pri validaci, nebot validace musi probehnout na
               originalnim poli bez oddelovacu, kvuli snadne kontrole.
               Neni to zrovna dobre reseni...

OnValidate - hlavni funkce pro ohodnoceni zda je vysledne pole v normalu
             ci nikoliv, kvuli ktere jsem tohle delal.

             ** Priklad na overeni rodneho cisla **

             procedure TForm1.PubEdit1Validate(Sender: TObject;
               Value: String;
               var CanExit: Boolean);
             Var E:Extended; // lokalni promenna
             begin
               CanExit:=True; // signal dopredu vse OK
               If Value='' Then Exit; // kdyz je pole prazdne, ven
               E:=StrToFloat(Value); // mozna zde to dat do try-except
               E:=E-11*(E/11); // vlastni overeni spravnosti
               CanExit := E=0; // spravne, kdyz je zbytek 0
             end;

Pouziti:
--------

Komponent je mozne volne (FREE) pouzit, s prihlednitum k soubeznym pravum.
Pouziti je na vlastni odpovednost uzivatele, nedavam zadne dalsi zaruky
pokud to neni nekde vyslovne uvedeno. Budete-li chtit zmenit cokoliv v teto
verzi, naleznete-li nejakou chybu nebo hodlate zvysit pouzitelnost,
dejte mi to, prosim, na vedomi.

Kontakt:
--------
Jaro Benes
E-mail:JBenes@micrel-dev.com
http://www.micrel-dev.com/delphi/
}
Const
  tyVersion          ='1.04 CZ';
  tyToAuthor         ='mailto="JBenes@micrel-dev.com"';
  msgNoFloatValue    ='Pole neobsahuje platn FP slo';
  msgNoIntegerValue  ='Pole neobsahuje platn slo';
  msgFieldRequired   ='Pole je poadovno vyplnit';
  msgMissingLBracket ='Chyb "("';
  msgMissingRBracket ='Chyb ")"';
  msgSyntaxError     ='Chyba syntaxe vrazu';
  msgUnknownFnc      ='Neznam funkce';
  msgInvalidOperation='Chybn operace';
  msgConvertValue    ='Chybn slo nebo operace na nm';
  msgFieldInvalidate ='Pole je chybn obsahem';
Type
  EvaluatorError=Class(Exception);
  {ohodnocujici procedura 11.11.1997}
  TValidate = Procedure (Sender: TObject;
                         Value: String;
                         Var CanExit: Boolean) Of Object;
  TToDirection = (eValueToText,eTextToValue);
  TConvert  = Procedure (Sender: TObject;
                         ToDirection:TToDirection;
                         Var Value:String) Of Object;
  TMaskForm = Procedure (Sender:TObject;
                         ToDirection:TToDirection;
                         Mask:String;
                         Var Value:String) Of Object;
  TErrorOccur = Procedure(Sender:TObject;
                          Const ErrorMsg:String) Of Object;
  {jak se zachovat k poli}
  TTypeEdit = (teString, teInteg, teFloat, teParser);

  TPubEdit = Class(TEdit)
   Private
    { Private declarations }
    FTypeEdit     : TTypeEdit; {typ pole s ruznymi akcemi}
    FValidate     : TValidate; {eventy}
    FConvert      : TConvert;
    FErrorOccur   : TErrorOccur;
    FMaskForm     : TMaskForm;
    FRequired     : Boolean; {neprazdne pole}
    FCapitalize   : Boolean; {prvni znaky slov velke}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FValids       : String;  {platne znaky napr. 'abcABC'}
    FMask         : String;  {maska napriklad 'XX.XX.XX/XX-XX'}
    FColorFocus   : TColor;  {barvicky}
    FColorUnFocus : TColor;
    FDisabledColor: TColor;
    Procedure SetRequired(Value:Boolean);
    Procedure SetCapitalize(Value:Boolean);
   Protected
    { Protected declarations }
    procedure KeyPress(var Key: Char); Override;
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
    Procedure NextControl( YesNo:Boolean) ; {nepouzil jsem}
   Public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
    Function    Parsed(Const S:String):String;
   Published
    property  AutoSelect;
    property  AutoSize;
    property  BorderStyle;
    Property  Capitalize: Boolean Read FCapitalize write SetCapitalize;
    Property  CharCase;
    Property  Color;
    property  ColorOnFocus : TColor read FColorFocus write FColorFocus;
    property  ColorOnNotFocus : TColor read FColorUnFocus write FColorUnFocus;
    property  ColorOnDisabled : TColor read FDisabledColor write FDisabledColor;
    Property  Ctl3D;
    Property  Cursor;
    Property  DragCursor;
    Property  DragMode;
    property  EditType : TTypeEdit read FTypeEdit write FTypeEdit;
    Property  Enabled;
    Property  Font;
    Property  Height;
    Property  HelpContext;
    Property  HideSelection;
    Property  Hint;
    Property  Left;
    Property  Mask:String Read FMask Write FMask;
    Property  MaxLength;
    Property  Name;
    Property  OEMConvert;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PasswordChar;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  ValidChars:String Read FValids Write FValids;
    Property  Visible;
    Property  Width;
    Property  OnChange;
    Property  OnClick;
    Property  OnConvert: TConvert Read FConvert Write FConvert;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnEndDrag;
    property  OnEnter: TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnError: TErrorOccur Read FErrorOccur Write FErrorOccur;
    property  OnExit : TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMask: TMaskForm Read FMaskForm Write FMaskForm;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
    Property  OnValidate: TValidate Read FValidate Write FValidate;
  End;

  TPubMaskEdit = Class(TMaskEdit)
   Private
    FValidate     : TValidate;
    FErrorOccur   : TErrorOccur;
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorFocus   : TColor;  {barvicky}
    FColorUnFocus : TColor;
    FDisabledColor: TColor;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    property  AutoSelect;
    property  AutoSize;
    property  BorderStyle;
    Property  CharCase;
    Property  Color;
    property  ColorOnFocus : TColor read FColorFocus write FColorFocus;
    property  ColorOnNotFocus : TColor read FColorUnFocus write FColorUnFocus;
    property  ColorOnDisabled : TColor read FDisabledColor write FDisabledColor;
    Property  Ctl3D;
    Property  Cursor;
    Property  DragCursor;
    Property  DragMode;
    Property  EditMask;
    Property  Enabled;
    Property  Font;
    Property  Height;
    Property  HelpContext;
    Property  Hint;
    Property  Left;
    Property  MaxLength;
    Property  Name;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PasswordChar;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  Visible;
    Property  Width;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnError: TErrorOccur Read FErrorOccur Write FErrorOccur;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
    Property  OnValidate: TValidate Read FValidate Write FValidate;
  End;

  {$IfDef Use_RX_Lib}

  TPubCurrencyEdit = Class(TCurrencyEdit)
   Private
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorFocus   : TColor;  {barvicky}
    FColorUnFocus : TColor;
    FDisabledColor: TColor;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    property  Alignment;
    property  AutoSelect;
    property  AutoSize;
    property  BeepOnError;
    property  BorderStyle;
    property  CheckOnExit;
    Property  Color;
    property  ColorOnFocus : TColor read FColorFocus write FColorFocus;
    property  ColorOnNotFocus : TColor read FColorUnFocus write FColorUnFocus;
    property  ColorOnDisabled : TColor read FDisabledColor write FDisabledColor;
    Property  Ctl3D;
    Property  Cursor;
    property  DecimalPlaces;
    property  DisplayFormat;
    Property  DragCursor;
    Property  DragMode;
    Property  Enabled;
    Property  Font;
    property  FormatOnEditing;
    Property  Height;
    Property  HelpContext;
    property  HideSelection;
    Property  Hint;
    Property  Left;
    Property  MaxLength;
    property  MaxValue;
    property  MinValue;
    Property  Name;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    property  Value;
    Property  Visible;
    Property  Width;
    property  ZeroEmpty;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
  End;

  {$EndIf}

  TPubComboBox= Class(TComboBox)
   Private
    FErrorOccur   : TErrorOccur;
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorFocus   : TColor;  {barvicky}
    FColorUnFocus : TColor;
    FDisabledColor: TColor;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    Property  Color;
    property  ColorOnFocus : TColor read FColorFocus write FColorFocus;
    property  ColorOnNotFocus : TColor read FColorUnFocus write FColorUnFocus;
    property  ColorOnDisabled : TColor read FDisabledColor write FDisabledColor;
    Property  Ctl3D;
    Property  Cursor;
    Property  DragCursor;
    Property  DragMode;
    Property  DropDownCount;
    Property  Enabled;
    Property  Font;
    Property  Height;
    Property  HelpContext;
    Property  Hint;
    Property  ItemHeight;
    Property  Items;
    Property  Left;
    Property  MaxLength;
    Property  Name;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupMenu;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  Sorted;
    Property  Style;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  Visible;
    Property  Width;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnDrawItem;
    Property  OnDropDown;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnError: TErrorOccur Read FErrorOccur Write FErrorOccur;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMeasureItem;
  End;

  {$IfDef Use_RX_Lib}

  TPubDateEdit = Class(TDateEdit)
   Private
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorFocus   : TColor;  {barvicky}
    FColorUnFocus : TColor;
    FDisabledColor: TColor;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    property  AutoSelect;
    Property  BlanksChar;
    property  BorderStyle;
    Property  ButtonHint;
    Property  ButtonWidth;
    Property  CalendarHints;
    Property  CalendarStyle;
    property  CheckOnExit;
    Property  Color;
    property  ColorOnFocus : TColor read FColorFocus write FColorFocus;
    property  ColorOnNotFocus : TColor read FColorUnFocus write FColorUnFocus;
    property  ColorOnDisabled : TColor read FDisabledColor write FDisabledColor;
    Property  Ctl3D;
    Property  Cursor;
    Property  DefaultToday;
    Property  DialogTitle;
    Property  DirectInput;
    Property  DragCursor;
    Property  DragMode;
    Property  Enabled;
    Property  Font;
    Property  Glyph;
    Property  Height;
    Property  HelpContext;
    property  HideSelection;
    Property  Hint;
    Property  Left;
    Property  MaxLength;
    Property  Name;
    Property  NumGlyphs;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupAlign;
    Property  PopupColor;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  StartOfWeek;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  Visible;
    Property  WeekendColor;
    Property  Weekends;
    Property  Width;
    Property  YearDigits;
    Property  OnAcceptDate;
    Property  OnButtonClick;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
  End;

  TPubFilenameEdit= Class(TFilenameEdit)
   Private
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorFocus   : TColor;  {barvicky}
    FColorUnFocus : TColor;
    FDisabledColor: TColor;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    Property  AcceptFiles;
    property  AutoSelect;
    property  BorderStyle;
    Property  ButtonHint;
    Property  ButtonWidth;
    Property  CharCase;
    Property  ClickKey;
    Property  Color;
    property  ColorOnFocus : TColor read FColorFocus write FColorFocus;
    property  ColorOnNotFocus : TColor read FColorUnFocus write FColorUnFocus;
    property  ColorOnDisabled : TColor read FDisabledColor write FDisabledColor;
    Property  Ctl3D;
    Property  Cursor;
    Property  DefaultExt;
    Property  DialogKind;
    Property  DialogOptions;
    Property  DialogTitle;
    Property  DirectInput;
    Property  DragCursor;
    Property  DragMode;
    Property  EditMask;
    Property  Enabled;
    Property  FileEditStyle;
    Property  FileName;
    Property  Filter;
    Property  FilterIndex;
    Property  Font;
    Property  Glyph;
    Property  GlyphKind;
    Property  Height;
    Property  HelpContext;
    property  HideSelection;
    Property  Hint;
    Property  HistoryList;
    Property  InitialDir;
    Property  Left;
    Property  Name;
    Property  NumGlyphs;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  Visible;
    Property  Width;
    Property  OnAfterDialog;
    Property  OnBeforeDialog;
    Property  OnButtonClick;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnDropFiles;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
  End;

  TPubDirectoryEdit= Class(TDirectoryEdit)
   Private
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorFocus   : TColor;  {barvicky}
    FColorUnFocus : TColor;
    FDisabledColor: TColor;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    Property  AcceptFiles;
    property  AutoSelect;
    property  BorderStyle;
    Property  ButtonHint;
    Property  ButtonWidth;
    Property  CharCase;
    Property  ClickKey;
    Property  Color;
    property  ColorOnFocus : TColor read FColorFocus write FColorFocus;
    property  ColorOnNotFocus : TColor read FColorUnFocus write FColorUnFocus;
    property  ColorOnDisabled : TColor read FDisabledColor write FDisabledColor;
    Property  Ctl3D;
    Property  Cursor;
    Property  DialogOptions;
    Property  DirectInput;
    Property  DragCursor;
    Property  DragMode;
    Property  EditMask;
    Property  Enabled;
    Property  Font;
    Property  Glyph;
    Property  GlyphKind;
    Property  Height;
    Property  HelpContext;
    property  HideSelection;
    Property  Hint;
    Property  InitialDir;
    Property  Left;
    Property  MultipleDirs;
    Property  Name;
    Property  NumGlyphs;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  Visible;
    Property  Width;
    Property  OnAfterDialog;
    Property  OnBeforeDialog;
    Property  OnButtonClick;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnDropFiles;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
  End;

  TPubRxCalcEdit= Class(TRxCalcEdit)
   Private
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorFocus   : TColor;  {barvicky}
    FColorUnFocus : TColor;
    FDisabledColor: TColor;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    Property  Alignment;
    property  AutoSelect;
    Property  AutoSize;
    Property  BeepOnError;
    property  BorderStyle;
    Property  ButtonHint;
    Property  ButtonWidth;
    Property  CheckOnExit;
    Property  ClickKey;
    Property  Color;
    property  ColorOnFocus : TColor read FColorFocus write FColorFocus;
    property  ColorOnNotFocus : TColor read FColorUnFocus write FColorUnFocus;
    property  ColorOnDisabled : TColor read FDisabledColor write FDisabledColor;
    Property  Ctl3D;
    Property  Cursor;
    Property  DecimalPlaces;
    Property  DirectInput;
    Property  DisplayFormat;
    Property  DragCursor;
    Property  DragMode;
    Property  Enabled;
    Property  Font;
    Property  FormatOnEditing;
    Property  Glyph;
    Property  GlyphKind;
    Property  Height;
    Property  HelpContext;
    property  HideSelection;
    Property  Hint;
    Property  Left;
    Property  MaxLength;
    Property  MaxValue;
    Property  MinValue;
    Property  Name;
    Property  NumGlyphs;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  Value;
    Property  Visible;
    Property  Width;
    Property  ZeroEmpty;
    Property  OnButtonClick;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
  End;

  TPubComboEdit= Class(TComboEdit)
   Private
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorFocus   : TColor;  {barvicky}
    FColorUnFocus : TColor;
    FDisabledColor: TColor;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    Property  Alignment;
    property  AutoSelect;
    property  BorderStyle;
    Property  ButtonHint;
    Property  ButtonWidth;
    Property  CharCase;
    Property  ClickKey;
    Property  Color;
    property  ColorOnFocus : TColor read FColorFocus write FColorFocus;
    property  ColorOnNotFocus : TColor read FColorUnFocus write FColorUnFocus;
    property  ColorOnDisabled : TColor read FDisabledColor write FDisabledColor;
    Property  Ctl3D;
    Property  Cursor;
    Property  DirectInput;
    Property  DragCursor;
    Property  DragMode;
    Property  EditMask;
    Property  Enabled;
    Property  Font;
    Property  Glyph;
    Property  GlyphKind;
    Property  Height;
    Property  HelpContext;
    property  HideSelection;
    Property  Hint;
    Property  Left;
    Property  MaxLength;
    Property  Name;
    Property  NumGlyphs;
    Property  OEMConvert;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  Visible;
    Property  Width;
    Property  OnButtonClick;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
  End;
  {$EndIf}

procedure Register;

Implementation

Constructor TPubEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  ColorOnFocus    := clYellow;
  ColorOnNotFocus := clWindow;
  ColorOnDisabled := clBtnFace;
  Color           := ColorOnNotFocus;
  FTypeEdit       := teString;
  FCapitalize     := False;
  FRequired       := False;
  FValids         := '';
  FMask           := '';
End;

Destructor TPubEdit.Destroy;
Begin
  Inherited Destroy;
End;

Procedure TPubEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubEdit.SetCapitalize(Value:Boolean);
Begin
  If Value <> FCapitalize Then
    FCapitalize := Value;
End;

Procedure TPubEdit.KeyPress(var Key: Char);
Var
 C: String;
 VCH: Set Of Char;
 I: Integer;
Begin
  If FTypeEdit = teString  Then Begin
    {nejprve vyrob mnozinu znaku}
    VCH := [];
    If Length(FValids) > 0 Then
      For I := 1 To Length(FValids) Do
        Include(VCH,Chr(Ord(FValids[I])));
    {ohodnot}
    If (Key <> #8{vk_TAB}) And (VCH <> []) Then
      If Not (Key In VCH) Then Key := #0; {Delej, jako by nebyla}

  End;

  {pro vstup cisel se predpoklada interne jina maska}
  If FTypeEdit = teInteg Then Begin
    {nejprve vyrob mnozinu znaku}
    VCH := ['0'..'9','+','-'];
    {ohodnot}
    If (Key <> #8{vk_TAB}) And (VCH <> []) Then
      If Not (Key In VCH) Then Key := #0; {Delej, jako by nebyla}
  End;

  {pro vstup cisel se predpoklada interne jina maska}
  If FTypeEdit = teFloat Then Begin
    {nejprve vyrob mnozinu znaku}
    VCH := ['0'..'9','+','-','.',',','e','E'];
    {ohodnot}
    If (Key <> #8{vk_TAB}) And (VCH <> []) Then
      If Not (Key In VCH) Then Key := #0; {Delej, jako by nebyla}
  End;

  {jsou-li pozadovana velka pismena na zacatku slov, udelej to tady}
  If FCapitalize Then
    If (SelStart = 0) Or (Text[SelStart] = ' ') Then Begin
      C := Key;
      C := AnsiUpperCase(C);
      Key := C[1];
    End;

  If Key <> #0 Then
    Inherited KeyPress(Key);
End;

Procedure TPubEdit.DoEnter;
Var S:String;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOnFocus;

  Case FTypeEdit of
  {je-li pozadovano prevedeni a jedna-li se o integ cislo}
    teInteg:
      If AsSigned(FConvert) Then Begin{je-li prislusna rutina}
        S:=Text;
        FConvert(Self,eValueToText,S); {preved text na jiny format}
        Text:=S;
      End;

  {je-li potreba zaformatovat podle masky, pak jenom pro string}
    teString:
      If AsSigned(FMaskForm) Then Begin
        S := Text;
        FMaskForm(Self,eValueToText,Mask,S);
        Text := S;
      End;

  End {case};

  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubEdit.DoExit;
Var
  L: LongInt;
  F: Extended;
  S: String;
  Err: Boolean;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOnNotFocus;
  Err:=False;
  Case FTypeEdit Of
    teInteg: If Text <> '' Then Begin
      {je-li ocekavano cislo, pak to cislo byt musi}
      Try
        L:=StrToInt(Text); {predpokladam Longint}
      Except
        on EConvertError Do Begin
          Err:=True;
          If AsSigned(FErrorOccur) Then
            {uzivatelska reakce na chybu}
            FErrorOccur(Self,msgNoIntegerValue)
          Else
            MessageDlg(msgNoIntegerValue,mtError, [mbOK],0);
          Self.SetFocus;
        End;
      End;
      {je-li pozadovano prevedeni a jedna-li se o integ cislo}
      If Not Err And AsSigned(FConvert) Then Begin{je-li prislusna rutina}
        S := Text;
        FConvert(Self,eTextToValue,S); {preved text na jiny format}
        Text := S;
      End;
    End;
    teFloat: If Text <> '' Then Begin
      {je-li ocekavano cislo, pak to cislo byt musi}
      Try
          F := StrToFloat(Text); {nejaky float}
        Except
          on EConvertError Do Begin
            Err := True;
            If AsSigned(FErrorOccur) Then
              {uzivatelska reakce na chybu}
              FErrorOccur(Self,msgNoFloatValue)
            Else
              MessageDlg(msgNoFloatValue,mtError, [mbOK],0);
            Self.SetFocus;
          End;
        End;
    End;
    teString:If Text <> '' Then Begin
      {je-li maska (ale i bez ni), pak formatuj externi rutinou}
      If AsSigned(FMaskForm) Then Begin
        S := Text;
        FMaskForm(Self,eTextToValue,Mask,S);
        Text := S;
      End;
    End;
  End {case};

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    If AsSigned(FErrorOccur) Then
      {uzivatelska reakce na chybu}
      FErrorOccur(Self,msgFieldRequired)
    Else
      MessageDlg(msgFieldRequired,mtWarning, [mbOK],0);
    SetFocus;
  End;

End;

Procedure TPubEdit.CMExit( Var Message : TCMExit );
Var
  CanExit: Boolean;
  S:String;
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
  {je-li pozadovana externi validace a neprojde, pak taky znovu}
  If FTypeEdit<>teParser Then Begin
    If Assigned(FValidate) Then Begin
      S := Text;{<-- text z editu}       {zmena maskovani 01.09.1999 J.B.}
      {pole nejlepe bez masek}
      If AsSigned(FMaskForm) Then FMaskForm(Self,eValueToText,Mask,S);
      {Vlastni validace}
      FValidate(Self, S, CanExit);
      {pri chybe zpet}
      If Not CanExit Then Begin
        MessageBeep($ffff); {pri chybe jenom pipni}
        (*If AsSigned(FErrorOccur) Then
          {uzivatelska reakce na chybu}
          FErrorOccur(Self,msgFieldInvalidate)
        Else
          MessageDlg(msgFieldInvalidate,mtWarning, [mbOK],0);*)
        Self.SetFocus;
        Exit;
      End;
    End;
  End
  Else
    {pro parser je validace extra zde}
    Text:=Parsed(Text);
End;

Procedure TPubEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  {obzvlast zajimave, nastavuji barvy :-( }
  If Enabled Then
    If Focused Then Color := ColorOnFocus
    Else Color := ColorOnNotFocus
  Else Color := ColorOnDisabled;
End;

Function TPubEdit.Parsed(Const S:String):String;

Const  EnableOpcode:string=('+-*/^');

  Function Evaluate(S:string):Extended;forward;

  Procedure MatchBracket(Var I:Integer;S:string);
  Var
    J,len:Integer;
  Begin
    If (Pos('(',S)=0) And (Pos(')',S)=0) Then Exit;
    J := 1;
    len := Length(S);
    Repeat
      Inc(i);
      If i > len Then
        Raise EvaluatorError.Create(msgMissingRBracket);
      If S[i]='(' Then Inc(j);
      If S[i]=')' Then Dec(j);
      If j<0 Then
        If AsSigned(FErrorOccur) Then
          {uzivatelska reakce na chybu}
          FErrorOccur(Self,msgMissingLBracket)
        Else
          Raise EvaluatorError.Create(msgMissingLBracket);
    Until j = 0;
  End;

  Function GetValue(S:String):extended;
  Begin
    If length(S) < 1 Then
      If AsSigned(FErrorOccur) Then
        {uzivatelska reakce na chybu}
        FErrorOccur(Self,msgSyntaxError)
      Else
        Raise EvaluatorError.Create(msgSyntaxError);
    Try
    If Length(S) = 1 Then
      Result := StrToFloat(S)
    Else
      Result := StrToFloat(S);
    Except
      on EConvertError Do Begin
        If AsSigned(FErrorOccur) Then
          {uzivatelska reakce na chybu}
          FErrorOccur(Self,msgNoFloatValue)
        Else
          Raise EvaluatorError.Create(msgNoFloatValue);
      End;
    End;
  End;

  Function SpecialFn(p1:Integer;S:String):Extended;
  Var
    operstr:String;
    arg:Extended;
  Begin
    operstr:=Copy(S,1,p1-1);
    If S[Length(S)] <> ')' Then
      If AsSigned(FErrorOccur) Then
        {uzivatelska reakce na chybu}
        FErrorOccur(Self,Format(msgSyntaxError+' %s',[S]))
      Else
        EvaluatorError.CreateFmt(msgSyntaxError+' %s',[S]);
    arg:=Evaluate(copy(S,p1+1,length(S)-p1-1));
    If operstr ='sin' Then Result:=sin(arg)
    Else
      If operstr ='cos' Then Result:=cos(arg)
      Else
        If operstr ='tan' Then Result:=sin(arg)/cos(arg)
        Else
          If operstr ='arctan' Then Result:=arctan(arg)
          Else
            If operstr ='log' Then Result:=ln(arg)/ln(10)
            Else
              If operstr ='ln' Then Result:=ln(arg)
              Else
                If operstr ='exp' Then Result:=exp(arg)
                Else
                  If operstr ='sqrt' Then result:=sqrt(arg)
                  {tady se daji pridat dalsi funkce}
                  Else Begin
                    If AsSigned(FErrorOccur) Then
                      {uzivatelska reakce na chybu}
                      FErrorOccur(Self,Format(msgUnknownFnc+' %s',[S]))
                    Else
                      Raise EvaluatorError.CreateFmt(msgUnknownFnc+' %s',[S]);
                  End
  End;

  Function Calculate(p1:Integer;S:String):Extended;
  Var
    v1,v2:Extended;
  Begin
    v1:=Evaluate(Copy(S,1,p1-1));
    v2:=Evaluate(Copy(S,p1+1,Length(S)-p1));
    Case S[p1] Of
      '+': result:=v1+v2;
       '-': result:=v1-v2;
       '/': result:=v1/v2;
       '*': result:=v1*v2;
       '^': result:=exp(v2*ln(v1));
    Else
      If AsSigned(FErrorOccur) Then
        {uzivatelska reakce na chybu}
        FErrorOccur(Self,Format(msgInvalidOperation+' %s',[S]))
      Else
        raise EparserError.CreateFmt(msgInvalidOperation+' %s',[S]);
    End;
  End;

  Function GetFirstOpp(tot:Integer;S:String):Integer;
  Var
    i:Integer;
  Begin
    If tot=0 Then tot := Length(S);
    For i := 1 To 5 Do Begin
      Result := Pos(EnableOpcode[i],S);
      If ((i<3) And (Result>0)) Then
        If ((Result=1) Or (Pos(S[Result-1],EnableOpcode)>0)) Then Result := 0;
      If result>0 Then
        If result<tot Then exit;
    End;
    If Result>tot Then Result:=0;
  End;

  Function Evaluate(S:string):Extended;
  Var
    p1,p2,q1:integer;
  Begin
    p1:=Pos('(',S);
    p2:=p1;
    If p2>0 Then matchbracket(p2,S);
    If p1=1 Then Begin
      If p2=Length(S) Then Begin
        Delete(S,p2,1);
        Delete(S,1,1);
        Result:=Evaluate(S);
      End
      Else
        Result:=Calculate(p2+1,S);
      Exit;
    End;
    q1:=GetFirstOpp(p1,S);
    If (p1+q1=0) Then Begin
      Result:=GetValue(S);
      Exit;
    End;
    If q1<>0 Then
      Result:=Calculate(q1,S)
    Else
      If Length(S)>p2 Then
        Result:=Calculate(p2+1,S)
      Else
        Result:=SpecialFn(p1,S);
  End;
  Procedure CleanUp(Var S:String);
  Var i:integer;
  Begin
    S:=LowerCase(S); {nepredpokladam cestinu :-))  }
    i:=Pos(' ',S);
    While i>0 Do Begin
      delete(S,i,1);
      i:=pos(' ',S);
    End;
  End;
Var X:String;
Begin
  Result := S;
  If S = '' Then Exit;
  X:=S;
  Try
     CleanUp(X);
     Result:=FloatToStr(Evaluate(X));
  Except
     On E:Exception Do
       If AsSigned(FErrorOccur) Then
         {uzivatelska reakce na chybu}
         FErrorOccur(Self,msgConvertValue+#13+'('+E.Message+')')
       Else
         MessageDlg(msgConvertValue+#13+'('+E.Message+')',mtError, [mbOK],0);
  End;
End;

Procedure TPubEdit.NextControl(YesNo:Boolean);
var
 FTempForm : {$IfDef Ver80}TForm{$Else}TCustomForm{$Endif};
begin

  if YesNo = True then begin
    FTempForm := GetParentForm(Self);
    SendMessage(FTempForm.Handle, WM_NEXTDLGCTL, 0, 0);
  end

end;

{*****************}

Constructor TPubMaskEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  ColorOnFocus    := clYellow;
  ColorOnNotFocus := clWindow;
  ColorOnDisabled := clBtnFace;
  Color           := ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubMaskEdit.Destroy;
Begin
  Inherited Destroy;
End;

Procedure TPubMaskEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubMaskEdit.DoEnter;
Var S:String;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOnFocus;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubMaskEdit.DoExit;
Var
  L: LongInt;
  F: Extended;
  S: String;
  Err: Boolean;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOnNotFocus;
  Err:=False;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    If AsSigned(FErrorOccur) Then
      {uzivatelska reakce na chybu}
      FErrorOccur(Self,msgFieldRequired)
    Else
      MessageDlg(msgFieldRequired,mtWarning, [mbOK],0);
    SetFocus;
  End;

End;

Procedure TPubMaskEdit.CMExit( Var Message : TCMExit );
Var
  CanExit: Boolean;
  S:String;
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
  {je-li pozadovana externi validace a neprojde, pak taky znovu}

  If Assigned(FValidate) Then Begin
    FValidate(Self, Text, CanExit);
    If Not CanExit Then Begin
      MessageBeep($ffff);
      Self.SetFocus;
      Exit;
    End;
  End;

End;

Procedure TPubMaskEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubMaskEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Not Enabled Then Color := ColorOnDisabled
  Else
    If Focused Then Color := ColorOnFocus
    Else Color := ColorOnNotFocus
End;

{*****************}
{$IfDef Use_RX_Lib}

Constructor TPubCurrencyEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  ColorOnFocus    := clYellow;
  ColorOnNotFocus := clWindow;
  ColorOnDisabled := clBtnFace;
  Color           := ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubCurrencyEdit.Destroy;
Begin
  Inherited Destroy;
End;

Procedure TPubCurrencyEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubCurrencyEdit.DoEnter;
Var S:String;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOnFocus;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubCurrencyEdit.DoExit;
Var
  L: LongInt;
  F: Extended;
  S: String;
  Err: Boolean;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOnNotFocus;
  Err:=False;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    If BeepOnError Then MessageBeep($ffff);
    SetFocus;
  End;

End;

Procedure TPubCurrencyEdit.CMExit( Var Message : TCMExit );
Var
  CanExit: Boolean;
  S:String;
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    If BeepOnError Then MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
End;

Procedure TPubCurrencyEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubCurrencyEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Not Enabled Then Color := ColorOnDisabled
  Else
    If Focused Then Color := ColorOnFocus
    Else Color := ColorOnNotFocus
End;
{$EndIf}
{*****************}

Constructor TPubComboBox.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  ColorOnFocus    := clYellow;
  ColorOnNotFocus := clWindow;
  ColorOnDisabled := clBtnFace;
  Color           := ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubComboBox.Destroy;
Begin
  Inherited Destroy;
End;

Procedure TPubComboBox.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubComboBox.DoEnter;
Var S:String;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOnFocus;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubComboBox.DoExit;
Var
  L: LongInt;
  F: Extended;
  S: String;
  Err: Boolean;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOnNotFocus;
  Err:=False;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    If AsSigned(FErrorOccur) Then
      {uzivatelska reakce na chybu}
      FErrorOccur(Self,msgFieldRequired)
    Else
      MessageDlg(msgFieldRequired,mtWarning, [mbOK],0);
    SetFocus;
  End;

End;

Procedure TPubComboBox.CMExit( Var Message : TCMExit );
Var
  CanExit: Boolean;
  S:String;
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
  {je-li pozadovana externi validace a neprojde, pak taky znovu}
End;

Procedure TPubComboBox.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubComboBox.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Not Enabled Then Color := ColorOnDisabled
  Else
    If Focused Then Color := ColorOnFocus
    Else Color := ColorOnNotFocus
End;

{*****************}
{$IfDef Use_RX_Lib}
Constructor TPubDateEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  ColorOnFocus    := clYellow;
  ColorOnNotFocus := clWindow;
  ColorOnDisabled := clBtnFace;
  Color           := ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubDateEdit.Destroy;
Begin
  Inherited Destroy;
End;

Procedure TPubDateEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubDateEdit.DoEnter;
Var S:String;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOnFocus;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubDateEdit.DoExit;
Var
  L: LongInt;
  F: Extended;
  S: String;
  Err: Boolean;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOnNotFocus;
  Err:=False;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    MessageBeep($ffff);
    SetFocus;
  End;

End;

Procedure TPubDateEdit.CMExit( Var Message : TCMExit );
Var
  CanExit: Boolean;
  S:String;
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
End;

Procedure TPubDateEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubDateEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Not Enabled Then Color := ColorOnDisabled
  Else
    If Focused Then Color := ColorOnFocus
    Else Color := ColorOnNotFocus
End;

{*****************}

Constructor TPubFilenameEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  ColorOnFocus    := clYellow;
  ColorOnNotFocus := clWindow;
  ColorOnDisabled := clBtnFace;
  Color           := ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubFilenameEdit.Destroy;
Begin
  Inherited Destroy;
End;

Procedure TPubFilenameEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubFilenameEdit.DoEnter;
Var S:String;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOnFocus;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubFilenameEdit.DoExit;
Var
  L: LongInt;
  F: Extended;
  S: String;
  Err: Boolean;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOnNotFocus;
  Err:=False;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    MessageBeep($ffff);
    SetFocus;
  End;

End;

Procedure TPubFilenameEdit.CMExit( Var Message : TCMExit );
Var
  CanExit: Boolean;
  S:String;
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
End;

Procedure TPubFilenameEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubFilenameEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Not Enabled Then Color := ColorOnDisabled
  Else
    If Focused Then Color := ColorOnFocus
    Else Color := ColorOnNotFocus
End;

{*****************}

Constructor TPubDirectoryEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  ColorOnFocus    := clYellow;
  ColorOnNotFocus := clWindow;
  ColorOnDisabled := clBtnFace;
  Color           := ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubDirectoryEdit.Destroy;
Begin
  Inherited Destroy;
End;

Procedure TPubDirectoryEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubDirectoryEdit.DoEnter;
Var S:String;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOnFocus;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubDirectoryEdit.DoExit;
Var
  L: LongInt;
  F: Extended;
  S: String;
  Err: Boolean;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOnNotFocus;
  Err:=False;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    MessageBeep($ffff);
    SetFocus;
  End;

End;

Procedure TPubDirectoryEdit.CMExit( Var Message : TCMExit );
Var
  CanExit: Boolean;
  S:String;
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
End;

Procedure TPubDirectoryEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubDirectoryEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Not Enabled Then Color := ColorOnDisabled
  Else
    If Focused Then Color := ColorOnFocus
    Else Color := ColorOnNotFocus
End;

{*****************}

Constructor TPubRxCalcEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  ColorOnFocus    := clYellow;
  ColorOnNotFocus := clWindow;
  ColorOnDisabled := clBtnFace;
  Color           := ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubRxCalcEdit.Destroy;
Begin
  Inherited Destroy;
End;

Procedure TPubRxCalcEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubRxCalcEdit.DoEnter;
Var S:String;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOnFocus;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubRxCalcEdit.DoExit;
Var
  L: LongInt;
  F: Extended;
  S: String;
  Err: Boolean;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOnNotFocus;
  Err:=False;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    If BeepOnError Then MessageBeep($ffff);
    SetFocus;
  End;

End;

Procedure TPubRxCalcEdit.CMExit( Var Message : TCMExit );
Var
  CanExit: Boolean;
  S:String;
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    If BeepOnError Then MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
End;

Procedure TPubRxCalcEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubRxCalcEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Not Enabled Then Color := ColorOnDisabled
  Else
    If Focused Then Color := ColorOnFocus
    Else Color := ColorOnNotFocus
End;

{*****************}

Constructor TPubComboEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  ColorOnFocus    := clYellow;
  ColorOnNotFocus := clWindow;
  ColorOnDisabled := clBtnFace;
  Color           := ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubComboEdit.Destroy;
Begin
  Inherited Destroy;
End;

Procedure TPubComboEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubComboEdit.DoEnter;
Var S:String;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOnFocus;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubComboEdit.DoExit;
Var
  L: LongInt;
  F: Extended;
  S: String;
  Err: Boolean;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOnNotFocus;
  Err:=False;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    MessageBeep($ffff);
    SetFocus;
  End;

End;

Procedure TPubComboEdit.CMExit( Var Message : TCMExit );
Var
  CanExit: Boolean;
  S:String;
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
End;

Procedure TPubComboEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubComboEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Not Enabled Then Color := ColorOnDisabled
  Else
    If Focused Then Color := ColorOnFocus
    Else Color := ColorOnNotFocus
End;
{$EndIf}


Procedure Register;
Begin
  RegisterComponents('Library',[TPubEdit,
                                TPubMaskEdit
                                {$IfDef Use_RX_Lib},
                                TPubCurrencyEdit
                                {$EndIf},
                                TPubComboBox
                                {$IfDef Use_RX_Lib},
                                TPubDateEdit,
                                TPubFilenameEdit,
                                TPubDirectoryEdit,
                                TPubComboEdit
                                {$EndIf}
                               ]);
End;

End.


